# Chapter 3 - Voxel Grammar Generation

## Description
grammar.h and grammar.cpp provide a C++ implementation of the voxel grammar defined in Chapter 3 of the thesis. 

## Usage
After a `Grammar` object has been instantiated, symbols and transforms can be added using the `addSymbol()` and `addTransform()` member functions, respectively.

These functions return integer indices for symbols and transforms that is used for adding rules. Rules can be added to the grammar via the `addRule()` function that takes an index to a symbol and a transform.

After all the desired rules have been added to the grammar, the `parse()` function then processes a voxel grid (a three-dimensional array of floats), for a number of iterations and results in voxels in the grid being manipulated according to any found rule matches.

Rulesets for generating data can be found in the thesis (Table 3.3 and Table 3.4).

## Dependencies
- GLM (https://github.com/g-truc/glm)